# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from yahoo_display_api.api_client import ApiClient
from yahoo_display_api.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class GuaranteedSimulationServiceApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def guaranteed_simulation_service_add_post(self, **kwargs):  # noqa: E501
        """guaranteed_simulation_service_add_post  # noqa: E501

        <div lang=\"ja\">   予約型キャンペーンの配信シミュレーションに関する情報を追加します。<br>   ※GuaranteedSimulationService/addによる配信シミュレーションの実施は、一部の利用者向けの限定機能となります。<br>   ※リクエスト制限は「最大5件/秒」固定です。サービス種別「campaign」とは別にカウントされます。 </div> <div lang=\"en\">   Adds information about the delivery simulation of the guaranteed campaign.<br>   * The delivery simulation implementation via GuaranteedSimulationService/add is a limited function for some users.<br>   * Request restrictions is a maximum of \"5 requests per second\". It counts separately from the service type \"campaign\". </div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.guaranteed_simulation_service_add_post(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param GuaranteedSimulationServiceOperation guaranteed_simulation_service_operation:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: GuaranteedSimulationServiceMutateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.guaranteed_simulation_service_add_post_with_http_info(**kwargs)  # noqa: E501

    def guaranteed_simulation_service_add_post_with_http_info(self, **kwargs):  # noqa: E501
        """guaranteed_simulation_service_add_post  # noqa: E501

        <div lang=\"ja\">   予約型キャンペーンの配信シミュレーションに関する情報を追加します。<br>   ※GuaranteedSimulationService/addによる配信シミュレーションの実施は、一部の利用者向けの限定機能となります。<br>   ※リクエスト制限は「最大5件/秒」固定です。サービス種別「campaign」とは別にカウントされます。 </div> <div lang=\"en\">   Adds information about the delivery simulation of the guaranteed campaign.<br>   * The delivery simulation implementation via GuaranteedSimulationService/add is a limited function for some users.<br>   * Request restrictions is a maximum of \"5 requests per second\". It counts separately from the service type \"campaign\". </div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.guaranteed_simulation_service_add_post_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param GuaranteedSimulationServiceOperation guaranteed_simulation_service_operation:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(GuaranteedSimulationServiceMutateResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'guaranteed_simulation_service_operation'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method guaranteed_simulation_service_add_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'guaranteed_simulation_service_operation' in local_var_params:
            body_params = local_var_params['guaranteed_simulation_service_operation']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/GuaranteedSimulationService/add', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GuaranteedSimulationServiceMutateResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def guaranteed_simulation_service_get_ad_category_post(self, **kwargs):  # noqa: E501
        """guaranteed_simulation_service_get_ad_category_post  # noqa: E501

        <div lang=\"ja\">予約型キャンペーンの配信シミュレーションにおける広告カテゴリー一覧を取得します。</div> <div lang=\"en\">Returns the list of ad categories in the delivery simulation of the guaranteed campaign.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.guaranteed_simulation_service_get_ad_category_post(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param object body:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: GuaranteedSimulationServiceGetAdCategoryResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.guaranteed_simulation_service_get_ad_category_post_with_http_info(**kwargs)  # noqa: E501

    def guaranteed_simulation_service_get_ad_category_post_with_http_info(self, **kwargs):  # noqa: E501
        """guaranteed_simulation_service_get_ad_category_post  # noqa: E501

        <div lang=\"ja\">予約型キャンペーンの配信シミュレーションにおける広告カテゴリー一覧を取得します。</div> <div lang=\"en\">Returns the list of ad categories in the delivery simulation of the guaranteed campaign.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.guaranteed_simulation_service_get_ad_category_post_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param object body:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(GuaranteedSimulationServiceGetAdCategoryResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'body'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method guaranteed_simulation_service_get_ad_category_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in local_var_params:
            body_params = local_var_params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/GuaranteedSimulationService/getAdCategory', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GuaranteedSimulationServiceGetAdCategoryResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def guaranteed_simulation_service_get_package_post(self, **kwargs):  # noqa: E501
        """guaranteed_simulation_service_get_package_post  # noqa: E501

        <div lang=\"ja\">予約型キャンペーンの配信シミュレーションのための商品一覧を取得します。</div> <div lang=\"en\">Gets the package list for the delivery simulation of the guaranteed campaign.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.guaranteed_simulation_service_get_package_post(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param GuaranteedSimulationServicePackageSelector guaranteed_simulation_service_package_selector:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: GuaranteedSimulationServiceGetPackageResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.guaranteed_simulation_service_get_package_post_with_http_info(**kwargs)  # noqa: E501

    def guaranteed_simulation_service_get_package_post_with_http_info(self, **kwargs):  # noqa: E501
        """guaranteed_simulation_service_get_package_post  # noqa: E501

        <div lang=\"ja\">予約型キャンペーンの配信シミュレーションのための商品一覧を取得します。</div> <div lang=\"en\">Gets the package list for the delivery simulation of the guaranteed campaign.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.guaranteed_simulation_service_get_package_post_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param GuaranteedSimulationServicePackageSelector guaranteed_simulation_service_package_selector:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(GuaranteedSimulationServiceGetPackageResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'guaranteed_simulation_service_package_selector'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method guaranteed_simulation_service_get_package_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'guaranteed_simulation_service_package_selector' in local_var_params:
            body_params = local_var_params['guaranteed_simulation_service_package_selector']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/GuaranteedSimulationService/getPackage', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GuaranteedSimulationServiceGetPackageResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def guaranteed_simulation_service_get_post(self, **kwargs):  # noqa: E501
        """guaranteed_simulation_service_get_post  # noqa: E501

        <div lang=\"ja\">予約型キャンペーンの配信シミュレーション結果に関する情報を取得します。</div> <div lang=\"en\">Returns the information about delivery simulation results of the guaranteed campaign.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.guaranteed_simulation_service_get_post(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param GuaranteedSimulationServiceSelector guaranteed_simulation_service_selector:
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: GuaranteedSimulationServiceGetResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.guaranteed_simulation_service_get_post_with_http_info(**kwargs)  # noqa: E501

    def guaranteed_simulation_service_get_post_with_http_info(self, **kwargs):  # noqa: E501
        """guaranteed_simulation_service_get_post  # noqa: E501

        <div lang=\"ja\">予約型キャンペーンの配信シミュレーション結果に関する情報を取得します。</div> <div lang=\"en\">Returns the information about delivery simulation results of the guaranteed campaign.</div>   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.guaranteed_simulation_service_get_post_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param GuaranteedSimulationServiceSelector guaranteed_simulation_service_selector:
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(GuaranteedSimulationServiceGetResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'guaranteed_simulation_service_selector'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method guaranteed_simulation_service_get_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'guaranteed_simulation_service_selector' in local_var_params:
            body_params = local_var_params['guaranteed_simulation_service_selector']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oAuth']  # noqa: E501

        return self.api_client.call_api(
            '/GuaranteedSimulationService/get', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GuaranteedSimulationServiceGetResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
