# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class AccountLinkServiceSelector(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'manager_account_id': 'int',
        'account_statuses': 'list[AccountLinkServiceAccountStatus]',
        'retargeting_list_sharing_enabled': 'AccountLinkServiceRetargetingListSharingEnabled',
        'number_results': 'int',
        'start_index': 'int'
    }

    attribute_map = {
        'manager_account_id': 'managerAccountId',
        'account_statuses': 'accountStatuses',
        'retargeting_list_sharing_enabled': 'retargetingListSharingEnabled',
        'number_results': 'numberResults',
        'start_index': 'startIndex'
    }

    def __init__(self, manager_account_id=None, account_statuses=None, retargeting_list_sharing_enabled=None, number_results=500, start_index=1, local_vars_configuration=None):  # noqa: E501
        """AccountLinkServiceSelector - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._manager_account_id = None
        self._account_statuses = None
        self._retargeting_list_sharing_enabled = None
        self._number_results = None
        self._start_index = None
        self.discriminator = None

        self.manager_account_id = manager_account_id
        self.account_statuses = account_statuses
        self.retargeting_list_sharing_enabled = retargeting_list_sharing_enabled
        self.number_results = number_results
        self.start_index = start_index

    @property
    def manager_account_id(self):
        """Gets the manager_account_id of this AccountLinkServiceSelector.  # noqa: E501

        <div lang=\"ja\">MCCアカウントIDです。</div> <div lang=\"en\">MCC Account ID.</div>   # noqa: E501

        :return: The manager_account_id of this AccountLinkServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._manager_account_id

    @manager_account_id.setter
    def manager_account_id(self, manager_account_id):
        """Sets the manager_account_id of this AccountLinkServiceSelector.

        <div lang=\"ja\">MCCアカウントIDです。</div> <div lang=\"en\">MCC Account ID.</div>   # noqa: E501

        :param manager_account_id: The manager_account_id of this AccountLinkServiceSelector.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and manager_account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `manager_account_id`, must not be `None`")  # noqa: E501

        self._manager_account_id = manager_account_id

    @property
    def account_statuses(self):
        """Gets the account_statuses of this AccountLinkServiceSelector.  # noqa: E501


        :return: The account_statuses of this AccountLinkServiceSelector.  # noqa: E501
        :rtype: list[AccountLinkServiceAccountStatus]
        """
        return self._account_statuses

    @account_statuses.setter
    def account_statuses(self, account_statuses):
        """Sets the account_statuses of this AccountLinkServiceSelector.


        :param account_statuses: The account_statuses of this AccountLinkServiceSelector.  # noqa: E501
        :type: list[AccountLinkServiceAccountStatus]
        """

        self._account_statuses = account_statuses

    @property
    def retargeting_list_sharing_enabled(self):
        """Gets the retargeting_list_sharing_enabled of this AccountLinkServiceSelector.  # noqa: E501


        :return: The retargeting_list_sharing_enabled of this AccountLinkServiceSelector.  # noqa: E501
        :rtype: AccountLinkServiceRetargetingListSharingEnabled
        """
        return self._retargeting_list_sharing_enabled

    @retargeting_list_sharing_enabled.setter
    def retargeting_list_sharing_enabled(self, retargeting_list_sharing_enabled):
        """Sets the retargeting_list_sharing_enabled of this AccountLinkServiceSelector.


        :param retargeting_list_sharing_enabled: The retargeting_list_sharing_enabled of this AccountLinkServiceSelector.  # noqa: E501
        :type: AccountLinkServiceRetargetingListSharingEnabled
        """

        self._retargeting_list_sharing_enabled = retargeting_list_sharing_enabled

    @property
    def number_results(self):
        """Gets the number_results of this AccountLinkServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :return: The number_results of this AccountLinkServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._number_results

    @number_results.setter
    def number_results(self, number_results):
        """Sets the number_results of this AccountLinkServiceSelector.

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :param number_results: The number_results of this AccountLinkServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results > 500):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value less than or equal to `500`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results < 1):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value greater than or equal to `1`")  # noqa: E501

        self._number_results = number_results

    @property
    def start_index(self):
        """Gets the start_index of this AccountLinkServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :return: The start_index of this AccountLinkServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._start_index

    @start_index.setter
    def start_index(self, start_index):
        """Sets the start_index of this AccountLinkServiceSelector.

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :param start_index: The start_index of this AccountLinkServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                start_index is not None and start_index < 1):  # noqa: E501
            raise ValueError("Invalid value for `start_index`, must be a value greater than or equal to `1`")  # noqa: E501

        self._start_index = start_index

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountLinkServiceSelector):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccountLinkServiceSelector):
            return True

        return self.to_dict() != other.to_dict()
