# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class AdGroupAdServiceCarouselAd(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'button_text': 'AdGroupAdServiceButtonText',
        'custom_parameters': 'AdGroupAdServiceCustomParameters',
        'display_url': 'str',
        'display_url_level': 'AdGroupAdServiceDisplayUrlLevel',
        'final_url': 'str',
        'smartphone_final_url': 'str',
        'is_remove_smartphone_final_url': 'AdGroupAdServiceIsRemoveFlg',
        'is_remove_tracking_url': 'AdGroupAdServiceIsRemoveFlg',
        'logo_media_id': 'int',
        'principal': 'str',
        'tracking_url': 'str',
        'url': 'str',
        'carousels': 'list[AdGroupAdServiceCarousel]'
    }

    attribute_map = {
        'button_text': 'buttonText',
        'custom_parameters': 'customParameters',
        'display_url': 'displayUrl',
        'display_url_level': 'displayUrlLevel',
        'final_url': 'finalUrl',
        'smartphone_final_url': 'smartphoneFinalUrl',
        'is_remove_smartphone_final_url': 'isRemoveSmartphoneFinalUrl',
        'is_remove_tracking_url': 'isRemoveTrackingUrl',
        'logo_media_id': 'logoMediaId',
        'principal': 'principal',
        'tracking_url': 'trackingUrl',
        'url': 'url',
        'carousels': 'carousels'
    }

    def __init__(self, button_text=None, custom_parameters=None, display_url=None, display_url_level=None, final_url=None, smartphone_final_url=None, is_remove_smartphone_final_url=None, is_remove_tracking_url=None, logo_media_id=None, principal=None, tracking_url=None, url=None, carousels=None, local_vars_configuration=None):  # noqa: E501
        """AdGroupAdServiceCarouselAd - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._button_text = None
        self._custom_parameters = None
        self._display_url = None
        self._display_url_level = None
        self._final_url = None
        self._smartphone_final_url = None
        self._is_remove_smartphone_final_url = None
        self._is_remove_tracking_url = None
        self._logo_media_id = None
        self._principal = None
        self._tracking_url = None
        self._url = None
        self._carousels = None
        self.discriminator = None

        self.button_text = button_text
        self.custom_parameters = custom_parameters
        self.display_url = display_url
        self.display_url_level = display_url_level
        self.final_url = final_url
        self.smartphone_final_url = smartphone_final_url
        self.is_remove_smartphone_final_url = is_remove_smartphone_final_url
        self.is_remove_tracking_url = is_remove_tracking_url
        self.logo_media_id = logo_media_id
        self.principal = principal
        self.tracking_url = tracking_url
        self.url = url
        self.carousels = carousels

    @property
    def button_text(self):
        """Gets the button_text of this AdGroupAdServiceCarouselAd.  # noqa: E501


        :return: The button_text of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: AdGroupAdServiceButtonText
        """
        return self._button_text

    @button_text.setter
    def button_text(self, button_text):
        """Sets the button_text of this AdGroupAdServiceCarouselAd.


        :param button_text: The button_text of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: AdGroupAdServiceButtonText
        """

        self._button_text = button_text

    @property
    def custom_parameters(self):
        """Gets the custom_parameters of this AdGroupAdServiceCarouselAd.  # noqa: E501


        :return: The custom_parameters of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: AdGroupAdServiceCustomParameters
        """
        return self._custom_parameters

    @custom_parameters.setter
    def custom_parameters(self, custom_parameters):
        """Sets the custom_parameters of this AdGroupAdServiceCarouselAd.


        :param custom_parameters: The custom_parameters of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: AdGroupAdServiceCustomParameters
        """

        self._custom_parameters = custom_parameters

    @property
    def display_url(self):
        """Gets the display_url of this AdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\"> 表示URLです。<br> ADDおよびSET時、このフィールドは省略可能となります。<br> ADD時にurlを指定する場合、このフィールドは必須です。<br> ADD時にfinalUrlを指定する場合、このフィールドを指定することはできません。代わりにfinalUrlから生成された値が自動で設定されます。<br> ただし、キャンペーン目的「アプリ訴求」の場合は、ADD、SETのどちらも指定できません。キャンペーンで指定したDeviceOsTypeに基づき、以下のいずれかのURLが自動で設定されます。<br> - iOSの場合：itunes.apple.com<br> - Androidの場合：play.google.com </div> <div lang=\"en\"> Display URL.<br> This field is optional in ADD and SET operation.<br> If you specify url in ADD operation, this field is required.<br> When finalUrl is specified in ADD operation, this field cannot be specified. Instead, the value generated from finalUrl will be set automatically.<br> However, not allowed for ADD and SET when a campaign goal is \"app promotion\". Based on DeviceOsType specified on the campaign, any of the following URLs will be automatically set.<br> - For iOS : itunes.apple.com<br> - For Android : play.google.com </div>   # noqa: E501

        :return: The display_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._display_url

    @display_url.setter
    def display_url(self, display_url):
        """Sets the display_url of this AdGroupAdServiceCarouselAd.

        <div lang=\"ja\"> 表示URLです。<br> ADDおよびSET時、このフィールドは省略可能となります。<br> ADD時にurlを指定する場合、このフィールドは必須です。<br> ADD時にfinalUrlを指定する場合、このフィールドを指定することはできません。代わりにfinalUrlから生成された値が自動で設定されます。<br> ただし、キャンペーン目的「アプリ訴求」の場合は、ADD、SETのどちらも指定できません。キャンペーンで指定したDeviceOsTypeに基づき、以下のいずれかのURLが自動で設定されます。<br> - iOSの場合：itunes.apple.com<br> - Androidの場合：play.google.com </div> <div lang=\"en\"> Display URL.<br> This field is optional in ADD and SET operation.<br> If you specify url in ADD operation, this field is required.<br> When finalUrl is specified in ADD operation, this field cannot be specified. Instead, the value generated from finalUrl will be set automatically.<br> However, not allowed for ADD and SET when a campaign goal is \"app promotion\". Based on DeviceOsType specified on the campaign, any of the following URLs will be automatically set.<br> - For iOS : itunes.apple.com<br> - For Android : play.google.com </div>   # noqa: E501

        :param display_url: The display_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._display_url = display_url

    @property
    def display_url_level(self):
        """Gets the display_url_level of this AdGroupAdServiceCarouselAd.  # noqa: E501


        :return: The display_url_level of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: AdGroupAdServiceDisplayUrlLevel
        """
        return self._display_url_level

    @display_url_level.setter
    def display_url_level(self, display_url_level):
        """Sets the display_url_level of this AdGroupAdServiceCarouselAd.


        :param display_url_level: The display_url_level of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: AdGroupAdServiceDisplayUrlLevel
        """

        self._display_url_level = display_url_level

    @property
    def final_url(self):
        """Gets the final_url of this AdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\">最終リンク先URLです。<br> ADD時、finalUrlフィールドとurlフィールドは同時に設定することはできず、どちらか片方の設定が必須となります。<br> finalUrlフィールドを設定する場合、smartphoneFinalUrl、trackingUrl、customParametersは任意になります。<br> SET時は省略可能となります。<br> SET時にurlを指定する場合、このフィールドの値はクリアされます。<br> キャンペーン目的「アプリ訴求」の場合は、このフィールドには以下のURLのみ設定できます。<br> - iOSの場合：itunes.apple.com<br> - Androidの場合：play.google.com </div> <div lang=\"en\">Final URL.<br> In ADD operation, finalUrl field and url field cannot be set at the same time, and one of them must be set.<br> If you specify finalUrl, smartphoneFinalUrl, trackingUrl and customParameters will be optional.<br> This field is optional in SET operation.<br> If url is specified in SET operation, the value in this field will be cleared.<br> If campaignGoal is APP_PROMOTION, only the following URL can be set in this field.<br> - For iOS : itunes.apple.com<br> - For Android : play.google.com </div>   # noqa: E501

        :return: The final_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._final_url

    @final_url.setter
    def final_url(self, final_url):
        """Sets the final_url of this AdGroupAdServiceCarouselAd.

        <div lang=\"ja\">最終リンク先URLです。<br> ADD時、finalUrlフィールドとurlフィールドは同時に設定することはできず、どちらか片方の設定が必須となります。<br> finalUrlフィールドを設定する場合、smartphoneFinalUrl、trackingUrl、customParametersは任意になります。<br> SET時は省略可能となります。<br> SET時にurlを指定する場合、このフィールドの値はクリアされます。<br> キャンペーン目的「アプリ訴求」の場合は、このフィールドには以下のURLのみ設定できます。<br> - iOSの場合：itunes.apple.com<br> - Androidの場合：play.google.com </div> <div lang=\"en\">Final URL.<br> In ADD operation, finalUrl field and url field cannot be set at the same time, and one of them must be set.<br> If you specify finalUrl, smartphoneFinalUrl, trackingUrl and customParameters will be optional.<br> This field is optional in SET operation.<br> If url is specified in SET operation, the value in this field will be cleared.<br> If campaignGoal is APP_PROMOTION, only the following URL can be set in this field.<br> - For iOS : itunes.apple.com<br> - For Android : play.google.com </div>   # noqa: E501

        :param final_url: The final_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._final_url = final_url

    @property
    def smartphone_final_url(self):
        """Gets the smartphone_final_url of this AdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\">スマートフォン向けURLです。<br> finalUrlを指定するときのみ、任意で指定できます。<br> キャンペーン目的「アプリ訴求」の場合は、ADD、SETのどちらも指定できません。<br> SET時にurlを指定する場合、このフィールドの値はクリアされます。 </div> <div lang=\"en\">Final URL (smartphone).<br> This field can be optionally specified only when specifying finalUrl.<br> Not allowed for ADD and SET when a campaign goal is \"app promotion\".<br> If url is specified in SET operation, the value in this field will be cleared. </div>   # noqa: E501

        :return: The smartphone_final_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._smartphone_final_url

    @smartphone_final_url.setter
    def smartphone_final_url(self, smartphone_final_url):
        """Sets the smartphone_final_url of this AdGroupAdServiceCarouselAd.

        <div lang=\"ja\">スマートフォン向けURLです。<br> finalUrlを指定するときのみ、任意で指定できます。<br> キャンペーン目的「アプリ訴求」の場合は、ADD、SETのどちらも指定できません。<br> SET時にurlを指定する場合、このフィールドの値はクリアされます。 </div> <div lang=\"en\">Final URL (smartphone).<br> This field can be optionally specified only when specifying finalUrl.<br> Not allowed for ADD and SET when a campaign goal is \"app promotion\".<br> If url is specified in SET operation, the value in this field will be cleared. </div>   # noqa: E501

        :param smartphone_final_url: The smartphone_final_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._smartphone_final_url = smartphone_final_url

    @property
    def is_remove_smartphone_final_url(self):
        """Gets the is_remove_smartphone_final_url of this AdGroupAdServiceCarouselAd.  # noqa: E501


        :return: The is_remove_smartphone_final_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: AdGroupAdServiceIsRemoveFlg
        """
        return self._is_remove_smartphone_final_url

    @is_remove_smartphone_final_url.setter
    def is_remove_smartphone_final_url(self, is_remove_smartphone_final_url):
        """Sets the is_remove_smartphone_final_url of this AdGroupAdServiceCarouselAd.


        :param is_remove_smartphone_final_url: The is_remove_smartphone_final_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: AdGroupAdServiceIsRemoveFlg
        """

        self._is_remove_smartphone_final_url = is_remove_smartphone_final_url

    @property
    def is_remove_tracking_url(self):
        """Gets the is_remove_tracking_url of this AdGroupAdServiceCarouselAd.  # noqa: E501


        :return: The is_remove_tracking_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: AdGroupAdServiceIsRemoveFlg
        """
        return self._is_remove_tracking_url

    @is_remove_tracking_url.setter
    def is_remove_tracking_url(self, is_remove_tracking_url):
        """Sets the is_remove_tracking_url of this AdGroupAdServiceCarouselAd.


        :param is_remove_tracking_url: The is_remove_tracking_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: AdGroupAdServiceIsRemoveFlg
        """

        self._is_remove_tracking_url = is_remove_tracking_url

    @property
    def logo_media_id(self):
        """Gets the logo_media_id of this AdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\"> ロゴの画像IDです。<br> このフィールドは、ADD時は必須となり、SET時は省略可能となります。<br> </div> <div lang=\"en\"> Logo image ID.<br> This field is required in ADD operation, and will be optional in SET operation.<br> </div>   # noqa: E501

        :return: The logo_media_id of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: int
        """
        return self._logo_media_id

    @logo_media_id.setter
    def logo_media_id(self, logo_media_id):
        """Sets the logo_media_id of this AdGroupAdServiceCarouselAd.

        <div lang=\"ja\"> ロゴの画像IDです。<br> このフィールドは、ADD時は必須となり、SET時は省略可能となります。<br> </div> <div lang=\"en\"> Logo image ID.<br> This field is required in ADD operation, and will be optional in SET operation.<br> </div>   # noqa: E501

        :param logo_media_id: The logo_media_id of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: int
        """

        self._logo_media_id = logo_media_id

    @property
    def principal(self):
        """Gets the principal of this AdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\"> 広告の主体者表記です。<br> このフィールドは、ADD時は必須となり、SET時は省略可能となります。<br> ただし、キャンペーン目的「アプリ訴求」の場合は、キャンペーンのアプリ名と同一の値が自動的に設定され、アプリ名以外の値は設定できません。 </div> <div lang=\"en\"> Advertiser Indication of the ad.<br> This field is required in ADD operation, and will be optional in SET operation.<br> However, if campaignGoal is APP_PROMOTION, it will automatically be set to the same value as appName of campaign, and it cannot be set to any other value. </div>   # noqa: E501

        :return: The principal of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._principal

    @principal.setter
    def principal(self, principal):
        """Sets the principal of this AdGroupAdServiceCarouselAd.

        <div lang=\"ja\"> 広告の主体者表記です。<br> このフィールドは、ADD時は必須となり、SET時は省略可能となります。<br> ただし、キャンペーン目的「アプリ訴求」の場合は、キャンペーンのアプリ名と同一の値が自動的に設定され、アプリ名以外の値は設定できません。 </div> <div lang=\"en\"> Advertiser Indication of the ad.<br> This field is required in ADD operation, and will be optional in SET operation.<br> However, if campaignGoal is APP_PROMOTION, it will automatically be set to the same value as appName of campaign, and it cannot be set to any other value. </div>   # noqa: E501

        :param principal: The principal of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._principal = principal

    @property
    def tracking_url(self):
        """Gets the tracking_url of this AdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\">トラッキングURLです。<br> ADD時、このフィールドは省略可能となります。<br> ※SET時、こちらが審査中の場合、編集はできません。<br> finalUrlを指定するときのみ、任意で指定できます。<br> SET時にurlを指定する場合、このフィールドの値はクリアされます。 </div> <div lang=\"en\">Tracking URL.<br> This field is optional in ADD operation.<br> *In SET operation, cannot update it when this field is in editorial review.<br> This field can be optionally specified only when specifying finalUrl.<br> If url is specified in SET operation, the value in this field will be cleared. </div>   # noqa: E501

        :return: The tracking_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._tracking_url

    @tracking_url.setter
    def tracking_url(self, tracking_url):
        """Sets the tracking_url of this AdGroupAdServiceCarouselAd.

        <div lang=\"ja\">トラッキングURLです。<br> ADD時、このフィールドは省略可能となります。<br> ※SET時、こちらが審査中の場合、編集はできません。<br> finalUrlを指定するときのみ、任意で指定できます。<br> SET時にurlを指定する場合、このフィールドの値はクリアされます。 </div> <div lang=\"en\">Tracking URL.<br> This field is optional in ADD operation.<br> *In SET operation, cannot update it when this field is in editorial review.<br> This field can be optionally specified only when specifying finalUrl.<br> If url is specified in SET operation, the value in this field will be cleared. </div>   # noqa: E501

        :param tracking_url: The tracking_url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._tracking_url = tracking_url

    @property
    def url(self):
        """Gets the url of this AdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\"> リンク先URLです。<br> アプリ訴求キャンペーンで設定可能なリンク先URLについては<a href=\"/reference/ads-display-api/v6/CampaignService/get/\">こちら</a>をご参照ください。<br> ADD時、urlフィールドとfinalUrlフィールドは同時に設定することはできず、どちらか片方の設定が必須となります。<br> urlフィールドを設定する場合、displayUrlの指定が必須になります。またその際は、finalUrl、smartphoneFinalUrl、trackingUrl、customParametersは指定不可です。<br> SET時は省略可能となります。<br> SET時にfinalUrlを指定する場合、このフィールドの値はクリアされます。 </div> <div lang=\"en\"> Destination URL.<br> For information about the destination URL that can be set with campaigns for \"app promotion\", refer to <a href=\"/reference/ads-display-api/v6/CampaignService/get/en/\">this page</a>.<br> In ADD operation, url field and finalUrl field cannot be set at the same time, and one of them must be set.<br> When url field is specified, displayUrl must be specified. In that case, finalUrl, smartphoneFinalUrl, trackingUrl and customParameters cannot be specified.<br> This field is optional in SET operation.<br> If finalUrl is specified in SET operation, the value in this field will be cleared. </div>   # noqa: E501

        :return: The url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this AdGroupAdServiceCarouselAd.

        <div lang=\"ja\"> リンク先URLです。<br> アプリ訴求キャンペーンで設定可能なリンク先URLについては<a href=\"/reference/ads-display-api/v6/CampaignService/get/\">こちら</a>をご参照ください。<br> ADD時、urlフィールドとfinalUrlフィールドは同時に設定することはできず、どちらか片方の設定が必須となります。<br> urlフィールドを設定する場合、displayUrlの指定が必須になります。またその際は、finalUrl、smartphoneFinalUrl、trackingUrl、customParametersは指定不可です。<br> SET時は省略可能となります。<br> SET時にfinalUrlを指定する場合、このフィールドの値はクリアされます。 </div> <div lang=\"en\"> Destination URL.<br> For information about the destination URL that can be set with campaigns for \"app promotion\", refer to <a href=\"/reference/ads-display-api/v6/CampaignService/get/en/\">this page</a>.<br> In ADD operation, url field and finalUrl field cannot be set at the same time, and one of them must be set.<br> When url field is specified, displayUrl must be specified. In that case, finalUrl, smartphoneFinalUrl, trackingUrl and customParameters cannot be specified.<br> This field is optional in SET operation.<br> If finalUrl is specified in SET operation, the value in this field will be cleared. </div>   # noqa: E501

        :param url: The url of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def carousels(self):
        """Gets the carousels of this AdGroupAdServiceCarouselAd.  # noqa: E501


        :return: The carousels of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: list[AdGroupAdServiceCarousel]
        """
        return self._carousels

    @carousels.setter
    def carousels(self, carousels):
        """Sets the carousels of this AdGroupAdServiceCarouselAd.


        :param carousels: The carousels of this AdGroupAdServiceCarouselAd.  # noqa: E501
        :type: list[AdGroupAdServiceCarousel]
        """

        self._carousels = carousels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdGroupAdServiceCarouselAd):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AdGroupAdServiceCarouselAd):
            return True

        return self.to_dict() != other.to_dict()
