# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class ConversionTrackerServiceAppConversion(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'app_conversion_platform': 'ConversionTrackerServiceAppConversionPlatform',
        'app_conversion_type': 'ConversionTrackerServiceAppConversionType',
        'app_id': 'str'
    }

    attribute_map = {
        'app_conversion_platform': 'appConversionPlatform',
        'app_conversion_type': 'appConversionType',
        'app_id': 'appId'
    }

    def __init__(self, app_conversion_platform=None, app_conversion_type=None, app_id=None, local_vars_configuration=None):  # noqa: E501
        """ConversionTrackerServiceAppConversion - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._app_conversion_platform = None
        self._app_conversion_type = None
        self._app_id = None
        self.discriminator = None

        self.app_conversion_platform = app_conversion_platform
        self.app_conversion_type = app_conversion_type
        self.app_id = app_id

    @property
    def app_conversion_platform(self):
        """Gets the app_conversion_platform of this ConversionTrackerServiceAppConversion.  # noqa: E501


        :return: The app_conversion_platform of this ConversionTrackerServiceAppConversion.  # noqa: E501
        :rtype: ConversionTrackerServiceAppConversionPlatform
        """
        return self._app_conversion_platform

    @app_conversion_platform.setter
    def app_conversion_platform(self, app_conversion_platform):
        """Sets the app_conversion_platform of this ConversionTrackerServiceAppConversion.


        :param app_conversion_platform: The app_conversion_platform of this ConversionTrackerServiceAppConversion.  # noqa: E501
        :type: ConversionTrackerServiceAppConversionPlatform
        """

        self._app_conversion_platform = app_conversion_platform

    @property
    def app_conversion_type(self):
        """Gets the app_conversion_type of this ConversionTrackerServiceAppConversion.  # noqa: E501


        :return: The app_conversion_type of this ConversionTrackerServiceAppConversion.  # noqa: E501
        :rtype: ConversionTrackerServiceAppConversionType
        """
        return self._app_conversion_type

    @app_conversion_type.setter
    def app_conversion_type(self, app_conversion_type):
        """Sets the app_conversion_type of this ConversionTrackerServiceAppConversion.


        :param app_conversion_type: The app_conversion_type of this ConversionTrackerServiceAppConversion.  # noqa: E501
        :type: ConversionTrackerServiceAppConversionType
        """

        self._app_conversion_type = app_conversion_type

    @property
    def app_id(self):
        """Gets the app_id of this ConversionTrackerServiceAppConversion.  # noqa: E501

        <div lang=\"ja\"> 計測対象のアプリIDです。<br> このフィールドは、ADD時は必須となり、SET時は無視されます。 </div> <div lang=\"en\"> App ID of the object to be tracked.<br> This field is required in ADD operation, and will be ignored in SET operation. </div>   # noqa: E501

        :return: The app_id of this ConversionTrackerServiceAppConversion.  # noqa: E501
        :rtype: str
        """
        return self._app_id

    @app_id.setter
    def app_id(self, app_id):
        """Sets the app_id of this ConversionTrackerServiceAppConversion.

        <div lang=\"ja\"> 計測対象のアプリIDです。<br> このフィールドは、ADD時は必須となり、SET時は無視されます。 </div> <div lang=\"en\"> App ID of the object to be tracked.<br> This field is required in ADD operation, and will be ignored in SET operation. </div>   # noqa: E501

        :param app_id: The app_id of this ConversionTrackerServiceAppConversion.  # noqa: E501
        :type: str
        """

        self._app_id = app_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConversionTrackerServiceAppConversion):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ConversionTrackerServiceAppConversion):
            return True

        return self.to_dict() != other.to_dict()
