# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class ConversionTrackerServiceWebConversionSnippet(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'tag': 'str',
        'advanced_tag': 'str',
        'web_conversion_snippet_type': 'ConversionTrackerServiceWebConversionSnippetType'
    }

    attribute_map = {
        'tag': 'tag',
        'advanced_tag': 'advancedTag',
        'web_conversion_snippet_type': 'webConversionSnippetType'
    }

    def __init__(self, tag=None, advanced_tag=None, web_conversion_snippet_type=None, local_vars_configuration=None):  # noqa: E501
        """ConversionTrackerServiceWebConversionSnippet - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._tag = None
        self._advanced_tag = None
        self._web_conversion_snippet_type = None
        self.discriminator = None

        self.tag = tag
        self.advanced_tag = advanced_tag
        self.web_conversion_snippet_type = web_conversion_snippet_type

    @property
    def tag(self):
        """Gets the tag of this ConversionTrackerServiceWebConversionSnippet.  # noqa: E501

        <div lang=\"ja\"> 従来のコンバージョンタグです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Previous tag of Conversion.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The tag of this ConversionTrackerServiceWebConversionSnippet.  # noqa: E501
        :rtype: str
        """
        return self._tag

    @tag.setter
    def tag(self, tag):
        """Sets the tag of this ConversionTrackerServiceWebConversionSnippet.

        <div lang=\"ja\"> 従来のコンバージョンタグです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Previous tag of Conversion.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param tag: The tag of this ConversionTrackerServiceWebConversionSnippet.  # noqa: E501
        :type: str
        """

        self._tag = tag

    @property
    def advanced_tag(self):
        """Gets the advanced_tag of this ConversionTrackerServiceWebConversionSnippet.  # noqa: E501

        <div lang=\"ja\"> リニューアル版のコンバージョンタグは、従来のタグよりもブラウザーなどの環境の影響を受けづらい新しいフォーマットです。<br> 詳細は、「<a href=\"https://ads-help.yahoo.co.jp/yahooads/display/articledetail?lan=ja&aid=59417\">コンバージョン測定とは</a>」を参照してください。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> The new format of conversion tag avoids the impacts such as changes made to the browser. <br> More details are described on <a https://ads-help.yahoo.co.jp/yahooads/display/articledetail?lan=en&aid=33889\">Conversion Analytics</a>.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The advanced_tag of this ConversionTrackerServiceWebConversionSnippet.  # noqa: E501
        :rtype: str
        """
        return self._advanced_tag

    @advanced_tag.setter
    def advanced_tag(self, advanced_tag):
        """Sets the advanced_tag of this ConversionTrackerServiceWebConversionSnippet.

        <div lang=\"ja\"> リニューアル版のコンバージョンタグは、従来のタグよりもブラウザーなどの環境の影響を受けづらい新しいフォーマットです。<br> 詳細は、「<a href=\"https://ads-help.yahoo.co.jp/yahooads/display/articledetail?lan=ja&aid=59417\">コンバージョン測定とは</a>」を参照してください。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> The new format of conversion tag avoids the impacts such as changes made to the browser. <br> More details are described on <a https://ads-help.yahoo.co.jp/yahooads/display/articledetail?lan=en&aid=33889\">Conversion Analytics</a>.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param advanced_tag: The advanced_tag of this ConversionTrackerServiceWebConversionSnippet.  # noqa: E501
        :type: str
        """

        self._advanced_tag = advanced_tag

    @property
    def web_conversion_snippet_type(self):
        """Gets the web_conversion_snippet_type of this ConversionTrackerServiceWebConversionSnippet.  # noqa: E501


        :return: The web_conversion_snippet_type of this ConversionTrackerServiceWebConversionSnippet.  # noqa: E501
        :rtype: ConversionTrackerServiceWebConversionSnippetType
        """
        return self._web_conversion_snippet_type

    @web_conversion_snippet_type.setter
    def web_conversion_snippet_type(self, web_conversion_snippet_type):
        """Sets the web_conversion_snippet_type of this ConversionTrackerServiceWebConversionSnippet.


        :param web_conversion_snippet_type: The web_conversion_snippet_type of this ConversionTrackerServiceWebConversionSnippet.  # noqa: E501
        :type: ConversionTrackerServiceWebConversionSnippetType
        """

        self._web_conversion_snippet_type = web_conversion_snippet_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConversionTrackerServiceWebConversionSnippet):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ConversionTrackerServiceWebConversionSnippet):
            return True

        return self.to_dict() != other.to_dict()
