# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class DictionaryServiceAudienceCategory(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'audience_category_type': 'str',
        'is_guaranteed_permitted': 'str',
        'child': 'list[DictionaryServiceAudienceCategory]',
        'code': 'str',
        'full_name': 'str',
        'name': 'str',
        'reach': 'int'
    }

    attribute_map = {
        'audience_category_type': 'audienceCategoryType',
        'is_guaranteed_permitted': 'isGuaranteedPermitted',
        'child': 'child',
        'code': 'code',
        'full_name': 'fullName',
        'name': 'name',
        'reach': 'reach'
    }

    def __init__(self, audience_category_type=None, is_guaranteed_permitted=None, child=None, code=None, full_name=None, name=None, reach=None, local_vars_configuration=None):  # noqa: E501
        """DictionaryServiceAudienceCategory - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._audience_category_type = None
        self._is_guaranteed_permitted = None
        self._child = None
        self._code = None
        self._full_name = None
        self._name = None
        self._reach = None
        self.discriminator = None

        self.audience_category_type = audience_category_type
        self.is_guaranteed_permitted = is_guaranteed_permitted
        self.child = child
        self.code = code
        self.full_name = full_name
        self.name = name
        self.reach = reach

    @property
    def audience_category_type(self):
        """Gets the audience_category_type of this DictionaryServiceAudienceCategory.  # noqa: E501

        <div lang=\"ja\">提供されるカテゴリの種別を表します。</div> <div lang=\"en\">Audience category information.</div> <dl class=term>   <dt class=\"term__item\">AFFINITY</dt>   <dd class=\"term__desc\"><span lang=\"ja\">興味関心です。</span><span lang=\"en\">Affinity.</span></dd>   <dt class=\"term__item\">IN_MARKET</dt>   <dd class=\"term__desc\"><span lang=\"ja\">購買意向です。</span><span lang=\"en\">In-market.</span></dd>   <dt class=\"term__item\">ATTRIBUTE_LIFE_EVENTS</dt>   <dd class=\"term__desc\"><span lang=\"ja\">属性ライフイベントです。</span><span lang=\"en\">Attribute-life-events.</span></dd>   <dt class=\"term__item\">UNKNOWN</dt>   <dd class=\"term__desc\"><span lang=\"ja\">未知の値です。</span><span lang=\"en\">Unknown Value.</span></dd> </dl>   # noqa: E501

        :return: The audience_category_type of this DictionaryServiceAudienceCategory.  # noqa: E501
        :rtype: str
        """
        return self._audience_category_type

    @audience_category_type.setter
    def audience_category_type(self, audience_category_type):
        """Sets the audience_category_type of this DictionaryServiceAudienceCategory.

        <div lang=\"ja\">提供されるカテゴリの種別を表します。</div> <div lang=\"en\">Audience category information.</div> <dl class=term>   <dt class=\"term__item\">AFFINITY</dt>   <dd class=\"term__desc\"><span lang=\"ja\">興味関心です。</span><span lang=\"en\">Affinity.</span></dd>   <dt class=\"term__item\">IN_MARKET</dt>   <dd class=\"term__desc\"><span lang=\"ja\">購買意向です。</span><span lang=\"en\">In-market.</span></dd>   <dt class=\"term__item\">ATTRIBUTE_LIFE_EVENTS</dt>   <dd class=\"term__desc\"><span lang=\"ja\">属性ライフイベントです。</span><span lang=\"en\">Attribute-life-events.</span></dd>   <dt class=\"term__item\">UNKNOWN</dt>   <dd class=\"term__desc\"><span lang=\"ja\">未知の値です。</span><span lang=\"en\">Unknown Value.</span></dd> </dl>   # noqa: E501

        :param audience_category_type: The audience_category_type of this DictionaryServiceAudienceCategory.  # noqa: E501
        :type: str
        """

        self._audience_category_type = audience_category_type

    @property
    def is_guaranteed_permitted(self):
        """Gets the is_guaranteed_permitted of this DictionaryServiceAudienceCategory.  # noqa: E501

        <div lang=\"ja\">予約型販売対象を表します</div> <div lang=\"en\">Indicates that it is subject to guaranteed sale.</div>   # noqa: E501

        :return: The is_guaranteed_permitted of this DictionaryServiceAudienceCategory.  # noqa: E501
        :rtype: str
        """
        return self._is_guaranteed_permitted

    @is_guaranteed_permitted.setter
    def is_guaranteed_permitted(self, is_guaranteed_permitted):
        """Sets the is_guaranteed_permitted of this DictionaryServiceAudienceCategory.

        <div lang=\"ja\">予約型販売対象を表します</div> <div lang=\"en\">Indicates that it is subject to guaranteed sale.</div>   # noqa: E501

        :param is_guaranteed_permitted: The is_guaranteed_permitted of this DictionaryServiceAudienceCategory.  # noqa: E501
        :type: str
        """

        self._is_guaranteed_permitted = is_guaranteed_permitted

    @property
    def child(self):
        """Gets the child of this DictionaryServiceAudienceCategory.  # noqa: E501

        <div lang=\"ja\">子要素としてDictionaryServiceAudienceCategoryオブジェクトを使用します。</div> <div lang=\"en\">DictionaryServiceAudienceCategory object is used.</div>   # noqa: E501

        :return: The child of this DictionaryServiceAudienceCategory.  # noqa: E501
        :rtype: list[DictionaryServiceAudienceCategory]
        """
        return self._child

    @child.setter
    def child(self, child):
        """Sets the child of this DictionaryServiceAudienceCategory.

        <div lang=\"ja\">子要素としてDictionaryServiceAudienceCategoryオブジェクトを使用します。</div> <div lang=\"en\">DictionaryServiceAudienceCategory object is used.</div>   # noqa: E501

        :param child: The child of this DictionaryServiceAudienceCategory.  # noqa: E501
        :type: list[DictionaryServiceAudienceCategory]
        """

        self._child = child

    @property
    def code(self):
        """Gets the code of this DictionaryServiceAudienceCategory.  # noqa: E501

        <div lang=\"ja\">カテゴリコードです。</div> <div lang=\"en\">Category code</div>   # noqa: E501

        :return: The code of this DictionaryServiceAudienceCategory.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this DictionaryServiceAudienceCategory.

        <div lang=\"ja\">カテゴリコードです。</div> <div lang=\"en\">Category code</div>   # noqa: E501

        :param code: The code of this DictionaryServiceAudienceCategory.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def full_name(self):
        """Gets the full_name of this DictionaryServiceAudienceCategory.  # noqa: E501

        <div lang=\"ja\">カテゴリ名称です。（カテゴリ名称、サブカテゴリ名称を含めた正式名称です。）</div> <div lang=\"en\">Category name (A formal name including category name and sub category name.)</div>   # noqa: E501

        :return: The full_name of this DictionaryServiceAudienceCategory.  # noqa: E501
        :rtype: str
        """
        return self._full_name

    @full_name.setter
    def full_name(self, full_name):
        """Sets the full_name of this DictionaryServiceAudienceCategory.

        <div lang=\"ja\">カテゴリ名称です。（カテゴリ名称、サブカテゴリ名称を含めた正式名称です。）</div> <div lang=\"en\">Category name (A formal name including category name and sub category name.)</div>   # noqa: E501

        :param full_name: The full_name of this DictionaryServiceAudienceCategory.  # noqa: E501
        :type: str
        """

        self._full_name = full_name

    @property
    def name(self):
        """Gets the name of this DictionaryServiceAudienceCategory.  # noqa: E501

        <div lang=\"ja\">サブカテゴリ名称です。</div> <div lang=\"en\">Sub-category name</div>   # noqa: E501

        :return: The name of this DictionaryServiceAudienceCategory.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DictionaryServiceAudienceCategory.

        <div lang=\"ja\">サブカテゴリ名称です。</div> <div lang=\"en\">Sub-category name</div>   # noqa: E501

        :param name: The name of this DictionaryServiceAudienceCategory.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def reach(self):
        """Gets the reach of this DictionaryServiceAudienceCategory.  # noqa: E501

        <div lang=\"ja\">リーチ数です。</div> <div lang=\"en\">Reach record number</div>   # noqa: E501

        :return: The reach of this DictionaryServiceAudienceCategory.  # noqa: E501
        :rtype: int
        """
        return self._reach

    @reach.setter
    def reach(self, reach):
        """Sets the reach of this DictionaryServiceAudienceCategory.

        <div lang=\"ja\">リーチ数です。</div> <div lang=\"en\">Reach record number</div>   # noqa: E501

        :param reach: The reach of this DictionaryServiceAudienceCategory.  # noqa: E501
        :type: int
        """

        self._reach = reach

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DictionaryServiceAudienceCategory):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DictionaryServiceAudienceCategory):
            return True

        return self.to_dict() != other.to_dict()
