# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class DictionaryServicePlacementCategoryList(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'placement_category_list_id': 'int',
        'placement_category_list_name': 'str',
        'placement_categories': 'list[DictionaryServicePlacementCategory]'
    }

    attribute_map = {
        'placement_category_list_id': 'placementCategoryListId',
        'placement_category_list_name': 'placementCategoryListName',
        'placement_categories': 'placementCategories'
    }

    def __init__(self, placement_category_list_id=None, placement_category_list_name=None, placement_categories=None, local_vars_configuration=None):  # noqa: E501
        """DictionaryServicePlacementCategoryList - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._placement_category_list_id = None
        self._placement_category_list_name = None
        self._placement_categories = None
        self.discriminator = None

        if placement_category_list_id is not None:
            self.placement_category_list_id = placement_category_list_id
        self.placement_category_list_name = placement_category_list_name
        self.placement_categories = placement_categories

    @property
    def placement_category_list_id(self):
        """Gets the placement_category_list_id of this DictionaryServicePlacementCategoryList.  # noqa: E501

        <div lang=\"ja\"> プレイスメントカテゴリーリストIDです。<br> </div> <div lang=\"en\"> Placement category list ID.<br> </div>   # noqa: E501

        :return: The placement_category_list_id of this DictionaryServicePlacementCategoryList.  # noqa: E501
        :rtype: int
        """
        return self._placement_category_list_id

    @placement_category_list_id.setter
    def placement_category_list_id(self, placement_category_list_id):
        """Sets the placement_category_list_id of this DictionaryServicePlacementCategoryList.

        <div lang=\"ja\"> プレイスメントカテゴリーリストIDです。<br> </div> <div lang=\"en\"> Placement category list ID.<br> </div>   # noqa: E501

        :param placement_category_list_id: The placement_category_list_id of this DictionaryServicePlacementCategoryList.  # noqa: E501
        :type: int
        """

        self._placement_category_list_id = placement_category_list_id

    @property
    def placement_category_list_name(self):
        """Gets the placement_category_list_name of this DictionaryServicePlacementCategoryList.  # noqa: E501

        <div lang=\"ja\"> プライスメントカテゴリリスト名です。<br> </div> <div lang=\"en\"> Placement category list name.<br> </div>   # noqa: E501

        :return: The placement_category_list_name of this DictionaryServicePlacementCategoryList.  # noqa: E501
        :rtype: str
        """
        return self._placement_category_list_name

    @placement_category_list_name.setter
    def placement_category_list_name(self, placement_category_list_name):
        """Sets the placement_category_list_name of this DictionaryServicePlacementCategoryList.

        <div lang=\"ja\"> プライスメントカテゴリリスト名です。<br> </div> <div lang=\"en\"> Placement category list name.<br> </div>   # noqa: E501

        :param placement_category_list_name: The placement_category_list_name of this DictionaryServicePlacementCategoryList.  # noqa: E501
        :type: str
        """

        self._placement_category_list_name = placement_category_list_name

    @property
    def placement_categories(self):
        """Gets the placement_categories of this DictionaryServicePlacementCategoryList.  # noqa: E501


        :return: The placement_categories of this DictionaryServicePlacementCategoryList.  # noqa: E501
        :rtype: list[DictionaryServicePlacementCategory]
        """
        return self._placement_categories

    @placement_categories.setter
    def placement_categories(self, placement_categories):
        """Sets the placement_categories of this DictionaryServicePlacementCategoryList.


        :param placement_categories: The placement_categories of this DictionaryServicePlacementCategoryList.  # noqa: E501
        :type: list[DictionaryServicePlacementCategory]
        """

        self._placement_categories = placement_categories

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DictionaryServicePlacementCategoryList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DictionaryServicePlacementCategoryList):
            return True

        return self.to_dict() != other.to_dict()
