# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class DictionaryServiceThirdPartyTrackingDomainValue(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'errors': 'list[Error]',
        'operation_succeeded': 'bool',
        'third_party_tracking_domain': 'list[DictionaryServiceThirdPartyTrackingDomain]'
    }

    attribute_map = {
        'errors': 'errors',
        'operation_succeeded': 'operationSucceeded',
        'third_party_tracking_domain': 'thirdPartyTrackingDomain'
    }

    def __init__(self, errors=None, operation_succeeded=None, third_party_tracking_domain=None, local_vars_configuration=None):  # noqa: E501
        """DictionaryServiceThirdPartyTrackingDomainValue - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._errors = None
        self._operation_succeeded = None
        self._third_party_tracking_domain = None
        self.discriminator = None

        self.errors = errors
        self.operation_succeeded = operation_succeeded
        self.third_party_tracking_domain = third_party_tracking_domain

    @property
    def errors(self):
        """Gets the errors of this DictionaryServiceThirdPartyTrackingDomainValue.  # noqa: E501


        :return: The errors of this DictionaryServiceThirdPartyTrackingDomainValue.  # noqa: E501
        :rtype: list[Error]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """Sets the errors of this DictionaryServiceThirdPartyTrackingDomainValue.


        :param errors: The errors of this DictionaryServiceThirdPartyTrackingDomainValue.  # noqa: E501
        :type: list[Error]
        """

        self._errors = errors

    @property
    def operation_succeeded(self):
        """Gets the operation_succeeded of this DictionaryServiceThirdPartyTrackingDomainValue.  # noqa: E501

        <div lang=\"ja\">処理結果です。trueの場合は、処理は成功しました。falseの場合は処理が失敗しています。</div> <div lang=\"en\">The process results. If true, the process succeeded. If false, the process failed.</div>   # noqa: E501

        :return: The operation_succeeded of this DictionaryServiceThirdPartyTrackingDomainValue.  # noqa: E501
        :rtype: bool
        """
        return self._operation_succeeded

    @operation_succeeded.setter
    def operation_succeeded(self, operation_succeeded):
        """Sets the operation_succeeded of this DictionaryServiceThirdPartyTrackingDomainValue.

        <div lang=\"ja\">処理結果です。trueの場合は、処理は成功しました。falseの場合は処理が失敗しています。</div> <div lang=\"en\">The process results. If true, the process succeeded. If false, the process failed.</div>   # noqa: E501

        :param operation_succeeded: The operation_succeeded of this DictionaryServiceThirdPartyTrackingDomainValue.  # noqa: E501
        :type: bool
        """

        self._operation_succeeded = operation_succeeded

    @property
    def third_party_tracking_domain(self):
        """Gets the third_party_tracking_domain of this DictionaryServiceThirdPartyTrackingDomainValue.  # noqa: E501


        :return: The third_party_tracking_domain of this DictionaryServiceThirdPartyTrackingDomainValue.  # noqa: E501
        :rtype: list[DictionaryServiceThirdPartyTrackingDomain]
        """
        return self._third_party_tracking_domain

    @third_party_tracking_domain.setter
    def third_party_tracking_domain(self, third_party_tracking_domain):
        """Sets the third_party_tracking_domain of this DictionaryServiceThirdPartyTrackingDomainValue.


        :param third_party_tracking_domain: The third_party_tracking_domain of this DictionaryServiceThirdPartyTrackingDomainValue.  # noqa: E501
        :type: list[DictionaryServiceThirdPartyTrackingDomain]
        """

        self._third_party_tracking_domain = third_party_tracking_domain

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DictionaryServiceThirdPartyTrackingDomainValue):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DictionaryServiceThirdPartyTrackingDomainValue):
            return True

        return self.to_dict() != other.to_dict()
