# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class GuaranteedInventoryJob(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'inventory_job_id': 'int',
        'inventory_job_name': 'str',
        'notification_business_ids': 'list[str]',
        'inventory_job_start_date': 'str',
        'inventory_job_end_date': 'str',
        'created_business_id': 'str',
        'is_expired_package': 'bool',
        'inventory_job_status': 'GuaranteedInventoryServiceInventoryJobStatus',
        'inventories': 'list[GuaranteedInventoryServiceInventory]'
    }

    attribute_map = {
        'account_id': 'accountId',
        'inventory_job_id': 'inventoryJobId',
        'inventory_job_name': 'inventoryJobName',
        'notification_business_ids': 'notificationBusinessIds',
        'inventory_job_start_date': 'inventoryJobStartDate',
        'inventory_job_end_date': 'inventoryJobEndDate',
        'created_business_id': 'createdBusinessId',
        'is_expired_package': 'isExpiredPackage',
        'inventory_job_status': 'inventoryJobStatus',
        'inventories': 'inventories'
    }

    def __init__(self, account_id=None, inventory_job_id=None, inventory_job_name=None, notification_business_ids=None, inventory_job_start_date=None, inventory_job_end_date=None, created_business_id=None, is_expired_package=None, inventory_job_status=None, inventories=None, local_vars_configuration=None):  # noqa: E501
        """GuaranteedInventoryJob - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._inventory_job_id = None
        self._inventory_job_name = None
        self._notification_business_ids = None
        self._inventory_job_start_date = None
        self._inventory_job_end_date = None
        self._created_business_id = None
        self._is_expired_package = None
        self._inventory_job_status = None
        self._inventories = None
        self.discriminator = None

        self.account_id = account_id
        self.inventory_job_id = inventory_job_id
        self.inventory_job_name = inventory_job_name
        self.notification_business_ids = notification_business_ids
        self.inventory_job_start_date = inventory_job_start_date
        self.inventory_job_end_date = inventory_job_end_date
        self.created_business_id = created_business_id
        self.is_expired_package = is_expired_package
        self.inventory_job_status = inventory_job_status
        self.inventories = inventories

    @property
    def account_id(self):
        """Gets the account_id of this GuaranteedInventoryJob.  # noqa: E501

        <div lang=\"ja\"> アカウントIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Account ID.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The account_id of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this GuaranteedInventoryJob.

        <div lang=\"ja\"> アカウントIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Account ID.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param account_id: The account_id of this GuaranteedInventoryJob.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def inventory_job_id(self):
        """Gets the inventory_job_id of this GuaranteedInventoryJob.  # noqa: E501

        <div lang=\"ja\">在庫確認ジョブIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Inventory check job ID.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The inventory_job_id of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: int
        """
        return self._inventory_job_id

    @inventory_job_id.setter
    def inventory_job_id(self, inventory_job_id):
        """Sets the inventory_job_id of this GuaranteedInventoryJob.

        <div lang=\"ja\">在庫確認ジョブIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Inventory check job ID.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param inventory_job_id: The inventory_job_id of this GuaranteedInventoryJob.  # noqa: E501
        :type: int
        """

        self._inventory_job_id = inventory_job_id

    @property
    def inventory_job_name(self):
        """Gets the inventory_job_name of this GuaranteedInventoryJob.  # noqa: E501

        <div lang=\"ja\">在庫確認ジョブ名です。<br> ADD時、このフィールドは必須となります。</div> <div lang=\"en\">Inventory check job name.<br> This field is required in ADD operation.</div>   # noqa: E501

        :return: The inventory_job_name of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: str
        """
        return self._inventory_job_name

    @inventory_job_name.setter
    def inventory_job_name(self, inventory_job_name):
        """Sets the inventory_job_name of this GuaranteedInventoryJob.

        <div lang=\"ja\">在庫確認ジョブ名です。<br> ADD時、このフィールドは必須となります。</div> <div lang=\"en\">Inventory check job name.<br> This field is required in ADD operation.</div>   # noqa: E501

        :param inventory_job_name: The inventory_job_name of this GuaranteedInventoryJob.  # noqa: E501
        :type: str
        """

        self._inventory_job_name = inventory_job_name

    @property
    def notification_business_ids(self):
        """Gets the notification_business_ids of this GuaranteedInventoryJob.  # noqa: E501

        <div lang=\"ja\">連絡先Yahoo! JAPANビジネスIDです。<br> ADD時、このフィールドは省略可能となります。</div> <div lang=\"en\">Yahoo! JAPAN Business ID to send notifications.<br> This field is optional in ADD operation.</div>   # noqa: E501

        :return: The notification_business_ids of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: list[str]
        """
        return self._notification_business_ids

    @notification_business_ids.setter
    def notification_business_ids(self, notification_business_ids):
        """Sets the notification_business_ids of this GuaranteedInventoryJob.

        <div lang=\"ja\">連絡先Yahoo! JAPANビジネスIDです。<br> ADD時、このフィールドは省略可能となります。</div> <div lang=\"en\">Yahoo! JAPAN Business ID to send notifications.<br> This field is optional in ADD operation.</div>   # noqa: E501

        :param notification_business_ids: The notification_business_ids of this GuaranteedInventoryJob.  # noqa: E501
        :type: list[str]
        """

        self._notification_business_ids = notification_business_ids

    @property
    def inventory_job_start_date(self):
        """Gets the inventory_job_start_date of this GuaranteedInventoryJob.  # noqa: E501

        <div lang=\"ja\"> 在庫確認ジョブの開始日時です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Start date of inventory check job.<br> Although this field will be returned in the response, it will be ignored on input. </div> Format: yyyyMMddHHmmss   # noqa: E501

        :return: The inventory_job_start_date of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: str
        """
        return self._inventory_job_start_date

    @inventory_job_start_date.setter
    def inventory_job_start_date(self, inventory_job_start_date):
        """Sets the inventory_job_start_date of this GuaranteedInventoryJob.

        <div lang=\"ja\"> 在庫確認ジョブの開始日時です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Start date of inventory check job.<br> Although this field will be returned in the response, it will be ignored on input. </div> Format: yyyyMMddHHmmss   # noqa: E501

        :param inventory_job_start_date: The inventory_job_start_date of this GuaranteedInventoryJob.  # noqa: E501
        :type: str
        """

        self._inventory_job_start_date = inventory_job_start_date

    @property
    def inventory_job_end_date(self):
        """Gets the inventory_job_end_date of this GuaranteedInventoryJob.  # noqa: E501

        <div lang=\"ja\"> 在庫確認ジョブの完了日時です。<br> 在庫確認ジョブが実行中の場合はnullで返ります。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\"> End date of inventory check job. <br> Null will be returned if the inventory check job is still running. <br> Although this field will be returned in the response, it will be ignored on input. </div> Format: yyyyMMddHHmmss   # noqa: E501

        :return: The inventory_job_end_date of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: str
        """
        return self._inventory_job_end_date

    @inventory_job_end_date.setter
    def inventory_job_end_date(self, inventory_job_end_date):
        """Sets the inventory_job_end_date of this GuaranteedInventoryJob.

        <div lang=\"ja\"> 在庫確認ジョブの完了日時です。<br> 在庫確認ジョブが実行中の場合はnullで返ります。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\"> End date of inventory check job. <br> Null will be returned if the inventory check job is still running. <br> Although this field will be returned in the response, it will be ignored on input. </div> Format: yyyyMMddHHmmss   # noqa: E501

        :param inventory_job_end_date: The inventory_job_end_date of this GuaranteedInventoryJob.  # noqa: E501
        :type: str
        """

        self._inventory_job_end_date = inventory_job_end_date

    @property
    def created_business_id(self):
        """Gets the created_business_id of this GuaranteedInventoryJob.  # noqa: E501

        <div lang=\"ja\">在庫確認ジョブ作成者のYahoo! JAPANビジネスIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Yahoo! JAPAN Business ID of inventory check job creator. <br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The created_business_id of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: str
        """
        return self._created_business_id

    @created_business_id.setter
    def created_business_id(self, created_business_id):
        """Sets the created_business_id of this GuaranteedInventoryJob.

        <div lang=\"ja\">在庫確認ジョブ作成者のYahoo! JAPANビジネスIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Yahoo! JAPAN Business ID of inventory check job creator. <br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param created_business_id: The created_business_id of this GuaranteedInventoryJob.  # noqa: E501
        :type: str
        """

        self._created_business_id = created_business_id

    @property
    def is_expired_package(self):
        """Gets the is_expired_package of this GuaranteedInventoryJob.  # noqa: E501

        <div lang=\"ja\"> 予約有効終了日が過去日の商品が指定されているかどうかのフラグです。<br> trueの場合、その商品の予約有効終了日を超えていることを示しています。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\"> A flag which indicates if the expired package is specified. <br> If the value is true, it indicates that the package reservation expiration date has already passed. <br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The is_expired_package of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: bool
        """
        return self._is_expired_package

    @is_expired_package.setter
    def is_expired_package(self, is_expired_package):
        """Sets the is_expired_package of this GuaranteedInventoryJob.

        <div lang=\"ja\"> 予約有効終了日が過去日の商品が指定されているかどうかのフラグです。<br> trueの場合、その商品の予約有効終了日を超えていることを示しています。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\"> A flag which indicates if the expired package is specified. <br> If the value is true, it indicates that the package reservation expiration date has already passed. <br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param is_expired_package: The is_expired_package of this GuaranteedInventoryJob.  # noqa: E501
        :type: bool
        """

        self._is_expired_package = is_expired_package

    @property
    def inventory_job_status(self):
        """Gets the inventory_job_status of this GuaranteedInventoryJob.  # noqa: E501


        :return: The inventory_job_status of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: GuaranteedInventoryServiceInventoryJobStatus
        """
        return self._inventory_job_status

    @inventory_job_status.setter
    def inventory_job_status(self, inventory_job_status):
        """Sets the inventory_job_status of this GuaranteedInventoryJob.


        :param inventory_job_status: The inventory_job_status of this GuaranteedInventoryJob.  # noqa: E501
        :type: GuaranteedInventoryServiceInventoryJobStatus
        """

        self._inventory_job_status = inventory_job_status

    @property
    def inventories(self):
        """Gets the inventories of this GuaranteedInventoryJob.  # noqa: E501


        :return: The inventories of this GuaranteedInventoryJob.  # noqa: E501
        :rtype: list[GuaranteedInventoryServiceInventory]
        """
        return self._inventories

    @inventories.setter
    def inventories(self, inventories):
        """Sets the inventories of this GuaranteedInventoryJob.


        :param inventories: The inventories of this GuaranteedInventoryJob.  # noqa: E501
        :type: list[GuaranteedInventoryServiceInventory]
        """

        self._inventories = inventories

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GuaranteedInventoryJob):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GuaranteedInventoryJob):
            return True

        return self.to_dict() != other.to_dict()
