# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class GuaranteedInventoryServiceAdRequirement(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ad_type': 'GuaranteedInventoryServiceAdType',
        'media_ad_format': 'str',
        'aspect_ratio': 'str'
    }

    attribute_map = {
        'ad_type': 'adType',
        'media_ad_format': 'mediaAdFormat',
        'aspect_ratio': 'aspectRatio'
    }

    def __init__(self, ad_type=None, media_ad_format=None, aspect_ratio=None, local_vars_configuration=None):  # noqa: E501
        """GuaranteedInventoryServiceAdRequirement - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ad_type = None
        self._media_ad_format = None
        self._aspect_ratio = None
        self.discriminator = None

        self.ad_type = ad_type
        self.media_ad_format = media_ad_format
        self.aspect_ratio = aspect_ratio

    @property
    def ad_type(self):
        """Gets the ad_type of this GuaranteedInventoryServiceAdRequirement.  # noqa: E501


        :return: The ad_type of this GuaranteedInventoryServiceAdRequirement.  # noqa: E501
        :rtype: GuaranteedInventoryServiceAdType
        """
        return self._ad_type

    @ad_type.setter
    def ad_type(self, ad_type):
        """Sets the ad_type of this GuaranteedInventoryServiceAdRequirement.


        :param ad_type: The ad_type of this GuaranteedInventoryServiceAdRequirement.  # noqa: E501
        :type: GuaranteedInventoryServiceAdType
        """

        self._ad_type = ad_type

    @property
    def media_ad_format(self):
        """Gets the media_ad_format of this GuaranteedInventoryServiceAdRequirement.  # noqa: E501

        <div lang=\"ja\"> メディアのフォーマットです。<br> ADD時、このフィールドは必須となります。<br> ※指定可能な値は、DictionaryServiceのgetMediaAdFormatで取得されるDictionaryServiceMediaAdFormatのadFormatフィールドをご確認ください。 </div> <div lang=\"en\"> Media format.<br> In ADD operation, this field will be required.<br> *Refer to the adFormat field of DictionaryServiceMediaAdFormat which can be obtained via getMediaAdFormat in DictionaryService, to check the values that can be specified in this field. </div>   # noqa: E501

        :return: The media_ad_format of this GuaranteedInventoryServiceAdRequirement.  # noqa: E501
        :rtype: str
        """
        return self._media_ad_format

    @media_ad_format.setter
    def media_ad_format(self, media_ad_format):
        """Sets the media_ad_format of this GuaranteedInventoryServiceAdRequirement.

        <div lang=\"ja\"> メディアのフォーマットです。<br> ADD時、このフィールドは必須となります。<br> ※指定可能な値は、DictionaryServiceのgetMediaAdFormatで取得されるDictionaryServiceMediaAdFormatのadFormatフィールドをご確認ください。 </div> <div lang=\"en\"> Media format.<br> In ADD operation, this field will be required.<br> *Refer to the adFormat field of DictionaryServiceMediaAdFormat which can be obtained via getMediaAdFormat in DictionaryService, to check the values that can be specified in this field. </div>   # noqa: E501

        :param media_ad_format: The media_ad_format of this GuaranteedInventoryServiceAdRequirement.  # noqa: E501
        :type: str
        """

        self._media_ad_format = media_ad_format

    @property
    def aspect_ratio(self):
        """Gets the aspect_ratio of this GuaranteedInventoryServiceAdRequirement.  # noqa: E501

        <div lang=\"ja\"> アスペクト比の種類です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Aspect ratio type.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The aspect_ratio of this GuaranteedInventoryServiceAdRequirement.  # noqa: E501
        :rtype: str
        """
        return self._aspect_ratio

    @aspect_ratio.setter
    def aspect_ratio(self, aspect_ratio):
        """Sets the aspect_ratio of this GuaranteedInventoryServiceAdRequirement.

        <div lang=\"ja\"> アスペクト比の種類です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Aspect ratio type.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param aspect_ratio: The aspect_ratio of this GuaranteedInventoryServiceAdRequirement.  # noqa: E501
        :type: str
        """

        self._aspect_ratio = aspect_ratio

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GuaranteedInventoryServiceAdRequirement):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GuaranteedInventoryServiceAdRequirement):
            return True

        return self.to_dict() != other.to_dict()
