# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class GuaranteedReservation(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'guaranteed_simulation_id': 'int',
        'lifetime_budget': 'int',
        'ad_group_name': 'str',
        'campaign_name': 'str',
        'notification_email_address': 'list[str]',
        'conversion_tracker': 'GuaranteedReservationServiceConversionTracker'
    }

    attribute_map = {
        'account_id': 'accountId',
        'guaranteed_simulation_id': 'guaranteedSimulationId',
        'lifetime_budget': 'lifetimeBudget',
        'ad_group_name': 'adGroupName',
        'campaign_name': 'campaignName',
        'notification_email_address': 'notificationEmailAddress',
        'conversion_tracker': 'conversionTracker'
    }

    def __init__(self, account_id=None, guaranteed_simulation_id=None, lifetime_budget=None, ad_group_name=None, campaign_name=None, notification_email_address=None, conversion_tracker=None, local_vars_configuration=None):  # noqa: E501
        """GuaranteedReservation - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._guaranteed_simulation_id = None
        self._lifetime_budget = None
        self._ad_group_name = None
        self._campaign_name = None
        self._notification_email_address = None
        self._conversion_tracker = None
        self.discriminator = None

        self.account_id = account_id
        self.guaranteed_simulation_id = guaranteed_simulation_id
        self.lifetime_budget = lifetime_budget
        self.ad_group_name = ad_group_name
        self.campaign_name = campaign_name
        self.notification_email_address = notification_email_address
        self.conversion_tracker = conversion_tracker

    @property
    def account_id(self):
        """Gets the account_id of this GuaranteedReservation.  # noqa: E501

        <div lang=\"ja\"> アカウントIDです。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Account ID.<br> This field is required in requests. </div>   # noqa: E501

        :return: The account_id of this GuaranteedReservation.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this GuaranteedReservation.

        <div lang=\"ja\"> アカウントIDです。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Account ID.<br> This field is required in requests. </div>   # noqa: E501

        :param account_id: The account_id of this GuaranteedReservation.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def guaranteed_simulation_id(self):
        """Gets the guaranteed_simulation_id of this GuaranteedReservation.  # noqa: E501

        <div lang=\"ja\"> シミュレーションIDです。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Simulation ID. <br> This field is required in requests. </div>   # noqa: E501

        :return: The guaranteed_simulation_id of this GuaranteedReservation.  # noqa: E501
        :rtype: int
        """
        return self._guaranteed_simulation_id

    @guaranteed_simulation_id.setter
    def guaranteed_simulation_id(self, guaranteed_simulation_id):
        """Sets the guaranteed_simulation_id of this GuaranteedReservation.

        <div lang=\"ja\"> シミュレーションIDです。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Simulation ID. <br> This field is required in requests. </div>   # noqa: E501

        :param guaranteed_simulation_id: The guaranteed_simulation_id of this GuaranteedReservation.  # noqa: E501
        :type: int
        """

        self._guaranteed_simulation_id = guaranteed_simulation_id

    @property
    def lifetime_budget(self):
        """Gets the lifetime_budget of this GuaranteedReservation.  # noqa: E501

        <div lang=\"ja\"> キャンペーンの通期予算額です。<br> ※この「通期予算」は、キャンペーンの全期間を通じて消費される予算を意味します。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> An amount of campaign's lifetime budget.<br> * \"lifetime budget\" means the total budget that is spent throughout the entire duration of the campaign.<br> This field is required in requests. </div>   # noqa: E501

        :return: The lifetime_budget of this GuaranteedReservation.  # noqa: E501
        :rtype: int
        """
        return self._lifetime_budget

    @lifetime_budget.setter
    def lifetime_budget(self, lifetime_budget):
        """Sets the lifetime_budget of this GuaranteedReservation.

        <div lang=\"ja\"> キャンペーンの通期予算額です。<br> ※この「通期予算」は、キャンペーンの全期間を通じて消費される予算を意味します。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> An amount of campaign's lifetime budget.<br> * \"lifetime budget\" means the total budget that is spent throughout the entire duration of the campaign.<br> This field is required in requests. </div>   # noqa: E501

        :param lifetime_budget: The lifetime_budget of this GuaranteedReservation.  # noqa: E501
        :type: int
        """

        self._lifetime_budget = lifetime_budget

    @property
    def ad_group_name(self):
        """Gets the ad_group_name of this GuaranteedReservation.  # noqa: E501

        <div lang=\"ja\"> 広告グループ名です。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Ad group name.<br> This field is required in requests. </div>   # noqa: E501

        :return: The ad_group_name of this GuaranteedReservation.  # noqa: E501
        :rtype: str
        """
        return self._ad_group_name

    @ad_group_name.setter
    def ad_group_name(self, ad_group_name):
        """Sets the ad_group_name of this GuaranteedReservation.

        <div lang=\"ja\"> 広告グループ名です。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Ad group name.<br> This field is required in requests. </div>   # noqa: E501

        :param ad_group_name: The ad_group_name of this GuaranteedReservation.  # noqa: E501
        :type: str
        """

        self._ad_group_name = ad_group_name

    @property
    def campaign_name(self):
        """Gets the campaign_name of this GuaranteedReservation.  # noqa: E501

        <div lang=\"ja\"> キャンペーン名です。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Campaign name.<br> This field is required in requests. </div>   # noqa: E501

        :return: The campaign_name of this GuaranteedReservation.  # noqa: E501
        :rtype: str
        """
        return self._campaign_name

    @campaign_name.setter
    def campaign_name(self, campaign_name):
        """Sets the campaign_name of this GuaranteedReservation.

        <div lang=\"ja\"> キャンペーン名です。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Campaign name.<br> This field is required in requests. </div>   # noqa: E501

        :param campaign_name: The campaign_name of this GuaranteedReservation.  # noqa: E501
        :type: str
        """

        self._campaign_name = campaign_name

    @property
    def notification_email_address(self):
        """Gets the notification_email_address of this GuaranteedReservation.  # noqa: E501

        <div lang=\"ja\"> 連絡先メールアドレスです。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Email address to send notifications.<br> This field is required in requests. </div>   # noqa: E501

        :return: The notification_email_address of this GuaranteedReservation.  # noqa: E501
        :rtype: list[str]
        """
        return self._notification_email_address

    @notification_email_address.setter
    def notification_email_address(self, notification_email_address):
        """Sets the notification_email_address of this GuaranteedReservation.

        <div lang=\"ja\"> 連絡先メールアドレスです。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Email address to send notifications.<br> This field is required in requests. </div>   # noqa: E501

        :param notification_email_address: The notification_email_address of this GuaranteedReservation.  # noqa: E501
        :type: list[str]
        """

        self._notification_email_address = notification_email_address

    @property
    def conversion_tracker(self):
        """Gets the conversion_tracker of this GuaranteedReservation.  # noqa: E501


        :return: The conversion_tracker of this GuaranteedReservation.  # noqa: E501
        :rtype: GuaranteedReservationServiceConversionTracker
        """
        return self._conversion_tracker

    @conversion_tracker.setter
    def conversion_tracker(self, conversion_tracker):
        """Sets the conversion_tracker of this GuaranteedReservation.


        :param conversion_tracker: The conversion_tracker of this GuaranteedReservation.  # noqa: E501
        :type: GuaranteedReservationServiceConversionTracker
        """

        self._conversion_tracker = conversion_tracker

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GuaranteedReservation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GuaranteedReservation):
            return True

        return self.to_dict() != other.to_dict()
