# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v6/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v6
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_api.configuration import Configuration


class GuaranteedSimulationServiceSingleTermBuyingTerm(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'buying_single_term_start_date': 'str',
        'buying_single_term_end_date': 'str'
    }

    attribute_map = {
        'buying_single_term_start_date': 'buyingSingleTermStartDate',
        'buying_single_term_end_date': 'buyingSingleTermEndDate'
    }

    def __init__(self, buying_single_term_start_date=None, buying_single_term_end_date=None, local_vars_configuration=None):  # noqa: E501
        """GuaranteedSimulationServiceSingleTermBuyingTerm - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._buying_single_term_start_date = None
        self._buying_single_term_end_date = None
        self.discriminator = None

        self.buying_single_term_start_date = buying_single_term_start_date
        self.buying_single_term_end_date = buying_single_term_end_date

    @property
    def buying_single_term_start_date(self):
        """Gets the buying_single_term_start_date of this GuaranteedSimulationServiceSingleTermBuyingTerm.  # noqa: E501

        <div lang=\"ja\">   商品購入期間（単一期間開始日）を表します。<br>   ※フォーマット：yyyyMMdd </div> <div lang=\"en\">   Start date of the package purchase term (single term).<br>   Format: yyyyMMdd </div>   # noqa: E501

        :return: The buying_single_term_start_date of this GuaranteedSimulationServiceSingleTermBuyingTerm.  # noqa: E501
        :rtype: str
        """
        return self._buying_single_term_start_date

    @buying_single_term_start_date.setter
    def buying_single_term_start_date(self, buying_single_term_start_date):
        """Sets the buying_single_term_start_date of this GuaranteedSimulationServiceSingleTermBuyingTerm.

        <div lang=\"ja\">   商品購入期間（単一期間開始日）を表します。<br>   ※フォーマット：yyyyMMdd </div> <div lang=\"en\">   Start date of the package purchase term (single term).<br>   Format: yyyyMMdd </div>   # noqa: E501

        :param buying_single_term_start_date: The buying_single_term_start_date of this GuaranteedSimulationServiceSingleTermBuyingTerm.  # noqa: E501
        :type: str
        """

        self._buying_single_term_start_date = buying_single_term_start_date

    @property
    def buying_single_term_end_date(self):
        """Gets the buying_single_term_end_date of this GuaranteedSimulationServiceSingleTermBuyingTerm.  # noqa: E501

        <div lang=\"ja\">   商品購入期間（単一期間終了日）を表します。<br>   ※フォーマット：yyyyMMdd </div> <div lang=\"en\">   End date of the package purchase term (single term).<br>   Format: yyyyMMdd </div>   # noqa: E501

        :return: The buying_single_term_end_date of this GuaranteedSimulationServiceSingleTermBuyingTerm.  # noqa: E501
        :rtype: str
        """
        return self._buying_single_term_end_date

    @buying_single_term_end_date.setter
    def buying_single_term_end_date(self, buying_single_term_end_date):
        """Sets the buying_single_term_end_date of this GuaranteedSimulationServiceSingleTermBuyingTerm.

        <div lang=\"ja\">   商品購入期間（単一期間終了日）を表します。<br>   ※フォーマット：yyyyMMdd </div> <div lang=\"en\">   End date of the package purchase term (single term).<br>   Format: yyyyMMdd </div>   # noqa: E501

        :param buying_single_term_end_date: The buying_single_term_end_date of this GuaranteedSimulationServiceSingleTermBuyingTerm.  # noqa: E501
        :type: str
        """

        self._buying_single_term_end_date = buying_single_term_end_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GuaranteedSimulationServiceSingleTermBuyingTerm):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GuaranteedSimulationServiceSingleTermBuyingTerm):
            return True

        return self.to_dict() != other.to_dict()
